	%++++++++++++++++++++++++++++++++++++++++
% Don't modify this section unless you know what you're doing!
\documentclass[a4paper,11pt]{article}
\usepackage[utf8]{inputenc}
\usepackage{mmap}
\usepackage[T1]{fontenc}
\usepackage[russian]{babel}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{ upgreek }   
\usepackage[most]{tcolorbox}
\usepackage{ulem} % ya dybil
\usepackage{tabularx} % extra features for tabular environment
\usepackage{amsmath,amssymb}  % improve math presentation
\usepackage{graphicx} % takes care of graphic including machinery
\usepackage[left=0.45in,right=0.45in,top=0.8in,bottom=0.8in,a4paper]{geometry} % decreases margins
\usepackage{cite} % takes care of citations
\usepackage[final]{hyperref} % adds hyper links inside the generated pdf file
%\usepackage{ dsfont }
\hypersetup{
	colorlinks=true,       % false: boxed links; true: colored links
	linkcolor=blue,        % color of internal links
	citecolor=blue,        % color of links to bibliography
	filecolor=magenta,     % color of file links
	urlcolor=blue         
}
\usepackage{amsthm,amsfonts,amscd}
\usepackage{blkarray}
\usepackage{mathtools}
\usepackage{fancyhdr}
\usepackage{xcolor,cancel}
\usepackage{tikz}
\usepackage{graphicx}
\usepackage{ifthen}
\usepackage{setspace}
\usepackage{epigraph}
\usepackage{verbatim}
\usepackage{algorithm2e}
%++++++++++++++++++++++++++++++++++++++++

\onehalfspacing

\setlength{\headheight}{14pt}
%++++++++++++++++++++++++++++++++++++++++

\newcommand{\warning}[1]{\textcolor{red}{#1}}
\newcommand{\graytext}[1]{\textcolor{gray!70}{#1}}

\newcommand\hcancel[2][black!50]{\setbox0=\hbox{$#2$}\rlap{\raisebox{.35\ht0}{\textcolor{#1}{\rule{\wd0}{0.6pt}}}}#2} 

%++++++++++++++++++++++++++++++++++++++++

\newtheoremstyle{break}% name
  {}%         Space above, empty = `usual value'
  {}%         Space below
  {\itshape}% Body font
  {}%         Indent amount (empty = no indent, \parindent = para indent)
  {\bfseries}% Thm head font
  {.}%        Punctuation after thm head
  {\newline}% Space after thm head: \newline = linebreak
  {}%         Thm head spec

% \theoremstyle{break}
\newtheorem*{theorem}{Теорема}
\newtheorem*{statement}{Утверждение}
\newtheorem*{lemma}{Лемма}
\newtheorem*{consequence}{Следствие}
\newtheorem*{cons}{Следствие}
\newtheorem*{properties}{Свойства}
\newtheorem*{property}{Свойство}
%\newtheorem*{proof}{Доказательство}

\theoremstyle{definition}
\newtheorem*{example}{Пример}
\newtheorem*{formula}{Формула}
\newtheorem*{fact}{Факт}
\newtheorem*{examples}{Примеры}
\newtheorem*{reminder}{Напоминание}
\newtheorem*{proposition}{Предложение}
\newtheorem*{definition}{Определение}
\newtheorem*{exercise}{Упражнение}
\newtheorem*{observation}{Замечание}
\newtheorem*{designation}{Обозначение}

% \abs and \norm

% \makeatletter
% \let\oldabs\abs
% \def\abs{\@ifstar{\oldabs}{\oldabs*}}
%
% \let\oldnorm\norm
% \def\norm{\@ifstar{\oldnorm}{\oldnorm*}}
% \makeatother

% shortcuts
\newcommand{\ttt}{\texttt}
\newcommand{\N}{\mathbb{N}} % set of natural numbers
\newcommand{\No}{\mathcal{N}}
\newcommand{\Z}{\mathbb{Z}} % set of integers
\newcommand{\Q}{\mathbb{Q}} % set of rational numbers
\newcommand{\I}{\mathbb{I}} % set of irrational numbers
\newcommand{\R}{\mathbb{R}} % set of real numbers
\newcommand{\RR}{\overline {\mathbb{R}}} % set of real numbers with infinity
\newcommand{\F}{\mathbb{F}} % finite field
\renewcommand{\C}{\mathbb{C}} % finite field
\newcommand{\A}{\mathcal{A}}
\newcommand{\B}{\mathcal{B}}
\newcommand{\E}{\mathcal{E}}
\newcommand{\X}{\mathcal{X}}
\renewcommand{\H}{\mathcal{H}}
\renewcommand{\P}{\mathcal{P}}
\renewcommand{\L}{\mathcal{L}} 
\renewcommand{\O}{\mathcal{O}}
\renewcommand{\o}{\mathcal{o}}
\newcommand{\EQ}{ \; \, \Leftrightarrow \; \, } % if and only if
\newcommand{\inff}{\text{inf}}
\renewcommand{\inf}{\infty}

% \newcommand{\O}{\varnothing} % empty set
\newcommand{\DEF}{\overset{Def}{=}}
\newcommand{\proofed}{$\blacksquare$}
\newcommand{\Ra}{\Rightarrow}
\newcommand{\La}{\Leftarrow}
\newcommand{\wtd}{\widetilde}
\newcommand{\ov}{\overline}
\newcommand{\us}{\underset}

%algebra
\newcommand{\dV}{\dim\,V}
\newcommand{\dW}{\dim\,W}
\newcommand{\Ker}{\text{Ker}\,}
\renewcommand{\Im}{\text{Im}\,}
\renewcommand{\Re}{\text{Re}\,}
\newcommand{\KerA}{\text{Ker}\,\A}
\newcommand{\rk}{\text{rk}\,}
\newcommand{\id}{\text{id}}
\newcommand{\Id}{\text{Id}\,}
\newcommand{\Lin}{\text{Lin}}
\newcommand{\Bil}{\text{Bil}}
\newcommand{\End}{\text{End}}
\newcommand{\EV}{\text{End}\,V}
\newcommand{\EW}{\text{End}\,W}
\newcommand{\charla}{\A-\la\cdot \Id_V}
\newcommand{\charlae}{\A-\la\E}
\newcommand{\Kercharla}{\Ker(\A-\la\cdot \Id_V)}
\newcommand{\eigsp}{V_{\la}}
\newcommand{\XA}{\X_{\A}}
\newcommand{\geom}{g_{\la}}
\newcommand{\algm}{a_{\la}}
\newcommand{\VC}{V_{\C}}
\newcommand{\AC}{\A_{\C}}
\newcommand{\Hom}{\text{Hom}}
\newcommand{\Mp}{M_1\times .. \times{M_n}}
\newcommand{\Mt}{M_1\otimes..\otimes{M_n}}
\newcommand{\mt}{m_1\otimes..\otimes{m_n}}
\newcommand{\mon}{m\otimes n}
\newcommand{\MoN}{M\otimes N}
\newcommand{\mos}{m\otimes s}
\newcommand{\MoS}{M\otimes S}
\newcommand{\VoW}{V\otimes W}
\newcommand{\vow}{v\otimes w}
\newcommand{\AoB }{\A\otimes\B}
\newcommand{\ext}{\bigwedge}
\newcommand{\extV}{\bigwedge^pV}

%diskra
\newcommand{\bin}{\{0,1\}}
\newcommand{\nt}{\texttt{NTime} }
\newcommand{\sz}{\texttt{size} }
\newcommand{\pp}{\texttt{P} }
\newcommand{\sat}{\texttt{SAT} }
\newcommand{\usat}{\texttt{USAT} }
\newcommand{\unsat}{\texttt{UNSAT} }
\newcommand{\maxsat}{\texttt{MAXSAT} }
\newcommand{\mvc}{\texttt{MIN-VERTEX COVER} }
\newcommand{\pcp}{\texttt{PCP} }
\newcommand{\ppp}{\texttt{P/poly} }
\renewcommand{\nl	}{\texttt{NL} }
\newcommand{\np}{\texttt{NP} }
\newcommand{\conp}{\texttt{coNP} }
\newcommand{\expp}{\texttt{EXP} }
\newcommand{\nexp}{\texttt{NEXP} }
\newcommand{\dt}{\texttt{DTime} }
\newcommand{\lp}{\leq_p}
\renewcommand{\ll}{\leq_l}
\newcommand{\lpt}{\leq_{p^T}}
\newcommand{\sbq}{\subseteq}
\newcommand{\sbnq}{\subsetneq}
\newcommand{\ds}{\ttt{DSpace}}
\newcommand{\ns}{\ttt{NSpace}}
\newcommand{\ps}{\ttt{PSPACE}}
\newcommand{\nps}{\ttt{NPSPACE}}
\newcommand{\ph}{\ttt{PH}}
\newcommand{\sip}{\Si_i^p}
\newcommand{\pip}{\Pi_i^p}
\newcommand{\HAB}{\H_{A, B}}
\newcommand{\hab}{h_{a, b}}
\newcommand{\HNN}{\H_{n, n}}
\newcommand{\HNK}{\H_{n, k}}
\newcommand{\csp}{\ttt{CSP}}
\newcommand{\qcsp}{\ttt{qCSP}}

% more beautiful comparision signs
\renewcommand{\le}{\leqslant}
\renewcommand{\leq}{\leqslant}
\renewcommand{\ge}{\geqslant}
\renewcommand{\geq}{\geqslant}


%greek symbols
\newcommand{\al}{\alpha}
\newcommand{\Si}{\Sigma}
\newcommand{\si}{\sigma}
\newcommand{\be}{\beta}
\newcommand{\ga}{\gamma}
\newcommand{\la}{\lambda}
\newcommand{\ve}{\varepsilon}
\newcommand{\vp}{\varphi}
\newcommand{\uo}{\upomega}
\newcommand{\oal}{\overline{\al}}
\newcommand{\Om}{\Omega}
\newcommand{\om}{\omega}
\newcommand{\ola}{\overline{\la}}

%matrix
\newcommand{\xvech}{(x_1, .., x_n)}
\newcommand{\alvech}{(\al_1, .., \al_n)}
\newcommand{\mvech}{(m_1, .., m_n)}
\newcommand{\alvecv}{\begin{pmatrix}
  \al_1\\
   ...\\
  \al_n
\end{pmatrix}}
\newcommand{\bevech}{(\be_1, .., \be_n)}
\newcommand{\bevecv}{\begin{pmatrix}
  \be_1\\
   ...\\
  \be_n
\end{pmatrix}}
\newcommand{\evech}{(e_1, .., e_n)}
\newcommand{\fvech}{(f_1, .., f_n)}
\newcommand{\fmvech}{(f_1, .., f_m)}
\newcommand{\amat}{\begin{pmatrix}
  a_{11}& ...&a_{1n} \\
   ...&...&...\\
  a_{n1}& ...&a_{nn}
\end{pmatrix}}

\newcommand{\ammat}{\begin{pmatrix}
  a_{11}& ...&a_{1m} \\
   ...&...&...\\
  a_{m1}& ...&a_{mm}
\end{pmatrix}}

\newcommand{\jo}{\text{J}_m(\al)}

\newcommand{\jomat}{\begin{pmatrix}
  \al &0 &0 &.. & 0 \\
  1 &\al &0& .. & 0 \\
  0 &1 &\al &.. & 0 \\
  .. & ..  &.. &..  & .. \\
  0  & 0  &0 &1 &\al
\end{pmatrix}}


\newcommand{\Xm}{X_{\mvech}}


\definecolor{block-gray}{gray}{0.90} 
\newtcolorbox{myquote}{colback=block-gray,grow to right by=-10mm,grow to left by=-10mm,
boxrule=0pt,boxsep=0pt,breakable} 

% defines
\newcommand{\set}[2][]{ %
  \ifthenelse{\equal{#1}{}} %
    { \left\{\ #2\ \right\} }%
    { \left\{\ #1\ |\ #2\ \right\} }%
}
% \set{1, 2, \ldots, n} = {1, 2, \ldots, n}
% \set[ x \in R ]{ \sin x = 0 } = { x \in \R | \sin x = 0 }

\lhead{ Теория алгоритмов}
\chead{ }
\rhead{Современное программирование, 2020}

\pagestyle{fancy}

\begin{document}
\begin{center}
  {\Large\bf
    Теория алгоритмов, весна 2020\\
    Лектор Ицыксон Д. М.
  }
\end{center}
\vspace*{-1em}\noindent \underline{\hbox to 1\textwidth{{ } \hfil{ } \hfil{ } }}


\tableofcontents
\setcounter{section}{-1}
\newpage
\input{section_0_desigantions}
\input{section_1_turing_machine}
\input{section_2_p_ppoly}
\input{section_3_np}
\input{section_4_karp_reduction}
\input{section_5_np_search}
\input{section_6_ladner_theorem}
\input{section_7_time_ierarchy_theorems}
\input{section_8_mem_limlit}
\input{section_9_poly_ierarchy}
\input{section_10_circuit_complexity}
\input{section_11_communication_complexity}
%todo sec 12
\input{section_13_hash_functions}
\input{section_14_sat_to_usat}
\input{section_15_pcp}
\input{section_16_matrix_games}
\input{section_17_yao_principle}
\end{document}

